/*********************************************************************
 *
 * Condor ClassAd library
 * Copyright (C) 1990-2001, CONDOR Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and Rajesh Raman.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of version 2.1 of the GNU Lesser General
 * Public License as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *********************************************************************/

#include "common.h"
#include "lexer.h"
#include "exprTree.h"
//#include "collection.h"
//#include "collectionBase.h"
#include "classad.h"

BEGIN_NAMESPACE( classad )
//-------------classad templates --------------

// function table
template std::map<std::string, void*, CaseIgnLTStr>;
template std::map<std::string, void*, CaseIgnLTStr>::iterator;

// attribute list
template _EXT_TEMPLATE::hash_map<std::string, ExprTree*, StringCaseIgnHash, CaseIgnEqStr>;
template _EXT_TEMPLATE::hash_map<std::string, ExprTree*, StringCaseIgnHash, CaseIgnEqStr>::iterator;
template _EXT_TEMPLATE::hash_map<std::string, ExprTree*, StringCaseIgnHash, CaseIgnEqStr>::const_iterator;

// expr evaluation cache
template _EXT_TEMPLATE::hash_map<const ExprTree*, Value, ExprHash >;
template _EXT_TEMPLATE::hash_map<const ExprTree*, Value, ExprHash >::iterator;

// component stuff
template std::vector< std::pair<std::string, ExprTree*> >;
template std::vector<ExprTree*>;

template std::map<std::string, ClassAd *>;
//template std::map<std::string, ClassAdCollection *>;

#ifdef CLASSAD_DISTRIBUTION
template std::vector<std::string>;
//#include "transaction.h"
//#include "view.h"

// view content
//template std::multiset<ViewMember, ViewMemberLT>;
//template std::multiset<ViewMember, ViewMemberLT>::iterator;

// list of sub-views
//template std::list<View*>;

// view registry
//template _EXT_TEMPLATE::hash_map<std::string,View*,StringHash>;
//template _EXT_TEMPLATE::hash_map<std::string,View*,StringHash>::iterator;

// index
//template _EXT_TEMPLATE::hash_map<std::string,std::multiset<ViewMember,ViewMemberLT>::iterator,
//    StringHash>::iterator;
//template _EXT_TEMPLATE::hash_map<std::string,std::multiset<ViewMember,ViewMemberLT>::iterator,
//    StringHash>;

// main classad table
//template _EXT_TEMPLATE::hash_map<std::string, ClassAdProxy, StringHash>;
//template _EXT_TEMPLATE::hash_map<std::string, ClassAdProxy, StringHash>::iterator;

// transaction registry
//template _EXT_TEMPLATE::hash_map<std::string, ServerTransaction*, StringHash>;
//template _EXT_TEMPLATE::hash_map<std::string, ServerTransaction*, StringHash>::iterator;

// operations in transaction
//template std::list<XactionRecord>;
#endif

class _ClassAdInit 
{
	public:
		_ClassAdInit( ) { tzset( ); }
} __ClassAdInit;

END_NAMESPACE
