/** $Id: tCA_RSSM.cc,v 1.3 2002/10/29 05:00:21 hdail Exp $
 */


/* ========================================================================= */
/*                                                                           */
/*    Copyright 2003,                                                        */
/*      Rice University,                                                     */
/*      University of California-San Diego,                                  */
/*      University of California-Santa Barbara,                              */
/*      University of Chicago,                                               */
/*      University of Houston,                                               */
/*      University of Illinois,                                              */
/*      University of Southern California-Information Sciences Institute,    */
/*      University of Tennessee-Knoxville.                                   */
/*                                                                           */
/*    All Rights Reserved.                                                   */
/*                                                                           */
/* See GrADSoft_Authors file in the GrADSoft top-level directory             */
/*                           for a list of developers.                       */
/*                                                                           */ 
/* Permission to use, copy, modify and distribute any part of this source    */
/* file of the Grid Application Development Software (GrADS) project for     */
/* educational, research and non-profit purposes, without fee, and without a */
/* written agreement is hereby granted, provided that the above copyright    */
/* notice, this paragraph and the following two paragraphs appear in all     */
/* copies.                                                                   */
/*                                                                           */
/*                                                                           */
/* IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS, EITHER JOINTLY OR    */
/* SEPARATELY, BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL,         */
/* INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT */
/* OF THE USE OF THIS SOFTWARE, EVEN IF THEY HAVE BEEN ADVISED OF THE        */
/* POSSIBILITY OF SUCH DAMAGE.                                               */
/*                                                                           */
/*                                                                           */
/* THIS SOFTWARE IS PROVIDED HEREIN ON AN "AS IS" BASIS, AND THE AUTHORS AND */
/* COPYRIGHT HOLDERS HAVE NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,     */
/* UPDATES, ENHANCEMENTS, OR MODIFICATIONS. THE AUTHORS AND COPYRIGHT        */
/* HOLDERS MAKE NO REPRESENTATIONS AND EXTEND NO WARRANTIES OF ANY KIND,     */
/* EITHER IMPLIED OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED     */
/* WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, OR     */
/* THAT THE USE OF THIS SOFTWARE WILL NOT INFRINGE ANY PATENT, TRADEMARK OR  */
/* OTHER RIGHTS.                                                             */
/*                                                                           */
/* ========================================================================= */

#include "syslog.h"
#include "tCA_RSSM.h"

///////////////////////////////////////////////////////////////////////
// RSSM general methods

// std constructor
catRSSM::catRSSM(AART* inputAART, AttListPtr ConfigListPtr) :
  RSSM(inputAART, ProbConfigListPtr) {

  Syslog::setVerbosity(WARNING);

  Syslog::log(DEBUG, "catRSSM", "constructor called");

  Rank_Function = copAART->Find_fAttr_ApplicationConstraint(RANK);
  if ( Rank_Function == (FunctionalAttribute *) NULL ) {
    Syslog::log(ERROR, "catRSSM", "Rank_Function not found");
  }

  Reqmts_Function = copAART->Find_fAttr_ApplicationConstraint(REQMTS);
  if ( Reqmts_Function == (FunctionalAttribute *) NULL ) {
    Syslog::log(ERROR, "catRSSM", "Reqmts_Function not found");
  }

}

catRSSM::~catRSSM() { 

  Syslog::log(DEBUG, "catRSSM", "destructor called");

}

AART *CreateAARTObject()
{
  return( construct_aartModel() );
}

RSSM *CreateRSSMObject(AART* inputAART, AttListPtr ConfigListPtr)
{
  catRSSM *catRSSMptr = new catRSSM(inputAART, ConfigListPtr);
  return((RSSM *)catRSSMptr);
}

